/*
*******************************************************************************
**
**  This device driver was created by Applilet for the 78K0S/KB1+, 78K0S/KA1+,
**  78K0S/KY1+ 8-Bit Single-Chip Microcontrollers.
**
**  Copyright(C) NEC Electronics Corporation 2002-2006
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	serial.h
**  Abstract :	This file implements device driver for serial module.
**  APIlib :	NEC78K0SKX1+.lib V1.50 [23 Feb. 2006]
**
**  Device :	uPD78F9222
**
**  Compiler :	NEC/CC78K0
**
*******************************************************************************
*/
#ifndef _MDSERIAL_
#define _MDSERIAL_

#define UART_ERR_PARITY		0x04		/* UART parity error */
#define UART_ERR_FRAME		0x02		/* UART frame error */
#define UART_ERR_OVERRUN	0x01		/* UART overrun error */
/*
*******************************************************************************
**  Global variables
*******************************************************************************
*/
/* 9600
#define	UART_BAUDRATE_M6	0x1
#define	UART_BAUDRATE_K6	0xd0
*/


/* 11500 */
#define	UART_BAUDRATE_M6	0x0
#define	UART_BAUDRATE_K6	0x23


void UART6_Init( void );
MD_STATUS UART6_SendData( UCHAR* txbuf, UCHAR txnum );
__interrupt void MD_INTST6( void );

#endif
