/* ------------------------------------------------------------------------------------ */
/* Interface 2008N@7                      		                        		*/
/*   iFTimer                                         		                		*/
/*   쐬: 2008.05.25                                         		        		*/
/*   쐬: Tachi			                                               				*/
/* ------------------------------------------------------------------------------------ */

/* 荞݃xN^ݒ  ---------------------------------------------------------------- */

#pragma interrupt  INTTM000 MD_INTTM000				/* INTTM000/CR000 ̊荞		*/
#pragma interrupt  INTTM010 MD_INTTM010				/* INTTM010/CR010 ̊荞		*/
#pragma interrupt  INTTM80 MD_INTTM80				/* INTTM80̊荞				*/

/* wb_t@CCN[h   ------------------------------------------------------- */
#include "macrodriver.h"
#include "timer.h"
#include "common.h" 
#include "timer_user.h"
#include "led.h"

/* }N`   ----------------------------------------------------------------------- */
#define	FADEOUT		1								/* bFade: tF[hAEg			*/
#define	FADESTOP	0								/* bFade: ʏ_				*/
#define	INITCR010	10								/* ʏ_CR010̒l			*/

#define	BLINKCYCLE	28								/* _Ŏ̏lC2.8bɑ	*/
													/* 6.4bɌ炵āC180b0	*/
													/* ɂȂ							*/

#define	OFFCYCLE	0								/* bCurStat: LED				*/
#define	ONCYCLE		1								/* bCurStat: LED_				*/
#define	OFFTIME		3								/* LEDTCND300msec		*/
#define	OVERTIME	1800							/* 180bD 100msec\䂦1800	*/

volatile	static	int		iCountTime;				/* ԃJEgpD3	*/
volatile	static	uchar	ucBlinkTime;			/* _ŎԂ̃JE^				*/
volatile	static	uchar	ucOnTime;				/* _Ă鎞ԁDς	*/
													/* _Ŏ𑁂߂Ă				*/
volatile	static	bool	bCountUp;				/* 3o߂ƂPɂȂtO		*/
volatile	static	bool	bCurStat;				/* _Ŏɓ_	*/
volatile	static	bool	bFade;					/* tF[hAEgǂ̃tO	*/

/* ֐vg^Cv錾 --------------------------------------------------------------- */
static void voBlinkLed(void); 						/* _Ő䏈						*/

/* 萔`     ----------------------------------------------------------------------- */

/* ϐ`     ----------------------------------------------------------------------- */

/* J֐     ----------------------------------------------------------------------- */

/*======================================================================================**
** StartTimer : ϐă^C}N
**    @@ Ȃ
**   ߂l    Ȃ
*/
void Timer_voStartTimer( )
{
	bFade = FADESTOP;								/* tF[hAEg~				*/
	iCountTime  = 0;								/* ԃJE^Ob					*/
	ucBlinkTime = 0;								/* _ŎԃJE^O				*/
	ucOnTime = BLINKCYCLE;							/* _ŊԊul					*/
	bCountUp = OFF;									/* vtOOFF				*/
	bCurStat = ONCYCLE;								/* _ł̏ԕϐ̏l͓_	*/
	CR010 = INITCR010;								/* LEDxőɂ				*/

	TM00_Start();									/* x(PWM)^C}n			*/
	TM80_Start();									/* ԃJEg^C}n			*/

	return;
}

/*======================================================================================**
** IsDone : 3vIׂ
**    @@ Ȃ
**   ߂l    ONF@OFFF܂
*/
bool Timer_bIsDone()								/* PɃtOԂ				*/
{                                                   /* Ƃđϐɂ̂	*/
	return bCountUp;								/* 悭ȂDJEgǂ̂悤	*/
}													/* ɊǗĂ邩́C̃W[	*/
													/* mĂ΂悢ƂȂ̂	*/
/*======================================================================================**
** GetCurTime : ݎԁioߎԁj𒲂ׂ
**    @@ Ȃ
**   ߂l    iCountTime  Pʂ100~b
*/
int Timer_iGetCurTime()	
{
	return iCountTime;
}

/* 荞ݏ ----------------------------------------------------------------------- */

/*======================================================================================**
** MD_INTTM000 : 16bitJE^̃RyAWX^CR000̊荞݃nh
**   @@@@@@LED̖xɎgpĂāC̃WX^PWM̎߂ĂD
**   @@@@@@tF[hAEǵC̊荞݃^C~OCR010̒lςĐ䂷D
**
**   TM000   ^|  ^|@@@ TM000CR000vłONAD܂CR000Ŏ߂Ă
**         ^  |^  |@@@ ł10msD̐ݒTM00_Init()ijŎ{D
**        @  
**   LED   ~~|_|~~|_|~~   @LEDHiŏLoœ_
**           ^ ^
**       CR010 CR000@@@@CR010̈vœ_CCR000̈vŏD
**                          CR010̒lς邱ƂŁCLEDg`̃f[eBς
**                          CR010ύX́Cől(= CR000̒l = TM_TM00_INTERVALVALUE)
**							1/10Ƃ邱ƂŁC10msTCN10 = 100ms ŃtF[h
**                          AEgD
*/
__interrupt void MD_INTTM000( )
{
	ushort	usCRval;

	Led_voLED1( LEDOFF );							/* LED1					*/

	if ( bFade == FADEOUT ){						/* tF[hAEgȂ			*/
		usCRval = CR010 + (ushort)( TM_TM00_INTERVALVALUE / 10 );
													/* | f[eB̂,CR010	*/
													/* | Zl߂D			*/
		if ( (ushort)( TM_TM00_INTERVALVALUE - 10 ) <= usCRval ){
													/* | vZlől𒴂Ȃ	*/
			usCRval = (ushort)(TM_TM00_INTERVALVALUE - 10);
													/* | | ől-10CR010̒lɂ	*/
			bFade = FADESTOP;						/* | | tF[h͏IƂ		*/
		} 

		CR010 = usCRval;							/* | CR010ɒlݒ				*/
	}												/* ^C}쒆CR010	*/
													/*   ɂ͐菇݂	*/
	return;											/*   ڂ̓foCX}jAQ	*/
}													/*   ͒PɖxϒȂ̂ŃVv	*/
													/*   ȏƂĂ				*/

/*======================================================================================**
** MD_INTTM010 : 16bitJE^̃RyAWX^CR010̊荞݁Dڍׂ͏LINTTM000QƁD
**   
**   
*/
__interrupt void MD_INTTM010( )
{
	Led_voLED1( LEDON );							/* LED1_						*/

	return;
}


/*======================================================================================**
** MD_INTTM80 : 8bitJE^TM80̊荞݁D100msecƂɌĂ΂D
**   
**   
*/
__interrupt void MD_INTTM80( void )
{
	EI();											/* f[eBύXD悷		*/
													/* ߂Ɋ荞݂				*/

	iCountTime++;									/* ԃJE^CNg		*/

	if ( ( iCountTime & 0x3f ) == 0 ){				/* 6.4bƂɏ		*/
		ucOnTime--;									/* | _ŊԊuZ				*/
	}												/* | 6.4b́CPANDZŋ	*/
													/* |   ₷lƂ			*/

	if ( OVERTIME < iCountTime ){					/* Ro߂					*/
		TM00_Stop();								/* | TM00^C}~				*/
		TM80_Stop();								/* | TM80^C}~				*/
		Led_voLED1( LEDOFF );						/* | LEDS					*/
		bCountUp = ON;								/* | JEgtOON			*/
	}
	else if ( 0x3f < iCountTime ){					/* RJEgȂ				*/
		voBlinkLed();								/* | LED_ŏ(Cŏ */
	}												/* | 6.4b͓_܂)			*/
	else{											/* ~Xh~̃Jelse				*/
		;
	}

	return;
}

/* ֐ --------------------------------------------------------------------------- */

/*======================================================================================**
** BlinkLed : _ŏD@TM80荞݂̒Ă΂
**    @@ Ȃ
**   ߂l    Ȃ
**
**       ONCYCLE  OFFCYCLE
**               
**@@~|__________|~|__________|~   LEDHiŏLoœ_
**      ucOnTime  OFFTIME@@@@@ _ԂucOnTimeɂĉρDԂOFFTIMEŌŒ
**                                  ܂_Ŏ ucOnTime + OFFTIME ƂȂD
**                                  ̎Ԃ ucBlinkTime ŃJEgD
*/
static void voBlinkLed()
{
	ucBlinkTime++;									/* _ł̎ԃJE^i߂		*/

	if ( bCurStat == ONCYCLE ){						/* _TCN̂Ƃ				*/
		if ( ucOnTime <= ucBlinkTime ){				/* | _Ԃo߂			*/
			bFade = FADEOUT;						/* | | tF[hAEgԂɂ		*/
			ucBlinkTime = 0;						/* | | ԃJE^			*/
			bCurStat = OFFCYCLE;					/* | | TCNɑJڂ		*/
		}
	}
	else{ /* if ( bCurStat == OFFCYCLE ) */			/* TCN̂Ƃ				*/
		if ( OFFTIME <= ucBlinkTime ){				/* | Ԃo߂			*/
			bFade = FADESTOP;						/* | IFADESTOPɂȂĂ͂	*/
													/* | ǔÔ					*/
			ucBlinkTime = 0;						/* | ԃJE^		*/
			bCurStat = ONCYCLE;						/* | _TCNɑJڂ			*/
			CR010 = INITCR010;						/* | CR010𖾓xőɂȂlɕύX	*/
		}
	}

	return;
}

/* end of file */
